/* === display.c === 	85-10-25 K.Takano  */
/*	(DeSmet C)   	86-06-16 K.Kohketsu*/
/*	(Microsoft C)	87-07-27 K.Kohketsu*/
/*	 + graph.c	87-09-02 K.Kohketsu*/
/*			87-11-21 K.Kohketsu*/
#include <dos.h>
#include <ctype.h>
#include <ctlname.h>
#define	VRAM	0xa000
#define ATTR	0xa200

extern union	REGS	inregs, outregs;
extern struct	SREGS	segregs;
extern char	aspfin, aflg, moving;
extern char	pflg, fflg, host, code;
extern unsigned	flog;
extern unsigned attr, bttr, clast;
extern unsigned ccol, crow, mincol, maxcol, minrow, maxrow;

extern char	cgraph ;			/* 0;  1:̕	*/
extern char	_gmode ;			/* graph mode  flag	*/
extern char	_gmodes;			/* 1;1/2  2:1/1	*/
extern char	_draw  ;			/* specify draw or move	*/
extern char	_drawn ;			/* specify drawn       	*/
extern char	_hidden;			/* graphic hidden flag	*/
extern char	_cleard;			/* specify esc_ff input	*/

static char	escmode = 0;			/* escape mode flag	*/
static char	pen[8]  = {0, 2, 1, 4, 3, 6, 5, 7}; /*DSCAN color codes	*/
static char	seqnum, seqstr[50];
static unsigned	savcol, savrow, savatr, savflg = 0;
static unsigned mode, color;

display( e )
unsigned char	e;
{
	if( escmode )	/* esc sequence	*/
		return( escseq( e ) );
	if(aflg == 1)	{ if(e == lf) if(!aspfin) return(0); }
	switch( e ) {
		case 0x11:		/* dc1 */
		case 0x13:		/* dc3 */
		case 0x18:		/* can */
		case syn :			break;
		case esc : escmode = 1;		break;
		case gs  : _gmode  = 1; _draw = 0; break;
		case us  : _gmode  = 0;		break;
		case bel : setcolor(pen[3]);
		case cr  : _gmode  = 0;
		default:
			  if(_gmode) graph( e );
			  else {
				if(_drawn) {
					_drawn = 0; cursoron();
					setcursor();
				}
				_cleard = 0; xvput( e );
			  }
	}
	return( 0 );
}

/* Note: if next rsget() was done then return 1 else return 0	*/
escseq( e )	/* GXP[vV[PX	*/
unsigned char	e;
{
	int	i;	unsigned char	c1,c2;
	escmode = 0;
	switch( e ) {
		/* eNgG~[^	*/
		case  ff : /* esc ff  ... clear T/G screen 	*/
			cls(1);
			if(! _hidden) chggraph();
			_cleard = 1; _gmode = 0;
			break;
		case  enq: /* esc enq ... send cursor pos. 	*/
			if(_gmode) rsput(0x29);	   /*g.stat	*/
			else	   rsput(0x25);    /*a.stat	*/
			sendaddr();	/* send cursor pos.	*/
			break;
		case  sub: /* esc sub ... cursor pos. input	*/
			gin();
			break;
		case 0x60: /* esc 0x60 ... normal line		*/
		case 0x61: /* esc  a   ... dot line		*/
		case 0x62: /* esc  b   ... dot and dush		*/
		case 0x63: /* esc  c   ... short dush		*/
		case 0x64: /* esc  d   ... long dush		*/
			setstyle( e-0x60 );
			break;
		/* D_SCAN color constol	 */
		case  '/': /* esc / Lc ... change color		*/
			setcolor( pen[ rsget() & 0x07 ] );
			return( 1 );
		case  '%': /* esc % Hc Lc Hr Lr Hb Lb Hg Lg 	*/
			   /* D_SCAN color level change		*/
			   /* ... skip				*/
			for( i=0; i<4; i++ )
				if( (rsget()&0x60)!=0x40 ) rsget();
			return( 1 );
		/* ANSI & ASPEN control	*/
		case '[' :
			seqnum = 0;
			do  { c1 = rsget();  seqstr[seqnum++] = c1; }
			while(! isalpha(c1));
			seqbra();
			return( 1 );
		case ')' :  /* esc ) 0..., 3...̕	*/
			if(rsget()=='3')  cgraph = 1;
			else		  cgraph = 0;
			return(1);
		case '=' :  /* esc = l c  ٱڽ		*/
			c1 = rsget()-' ';  c2 = rsget()-' ';
			vlocate(c2, c1);   return(1);
		case '*' :  /* esc *      ʸر		*/
			cls(aflg);  break;
		case 'D' :  /* esc D	  cursor down		*/
			if(++crow > maxrow) vscroll();  break;
		case 'E' :  /* esc D	  cursor down and CR	*/
			if(++crow > maxrow) vscroll();
			ccol = mincol;  break;
		case 'M' :  /* esc M	  cursor up		*/
			if(--crow < minrow) vscrup();   break;
		case 's' :  /* esc s	  save cursor position	*/
			savcol = ccol;  savrow = crow;
			savatr = attr;  savflg = 1;	break;
		case 'u' :  /* esc u	  set cursor position	*/
			if( savflg ) {ccol=savcol; crow=savrow; attr=savatr;}
			else	     {ccol=mincol; crow=minrow; attr=bttr  ;}
			savflg = 0;	break;
		case esc: escmode = 1;	break;
		case gs : _gmode  = 1;	break;
		case us : _gmode  = 0;	break;
		case cr : _gmode  = 0;	break;
		default : break;
	}
	return( 0 );
}

seqbra()
{
	unsigned  n, m, ccr, scol, srow, trow;
	char	  s1[2], s2[2];
	if(seqnum == 1)  n = 1;
	else {
		if(seqnum == 3) n = (seqstr[0]-'0')*10 + (seqstr[1]-'0');
		else		n =  seqstr[0]-'0';
	}
	if(n == 0)  n = 1;
	switch( seqstr[seqnum-1] ) {
		case 'f': seqstr[seqnum-1] = 'H';
		case 'H':
			if(seqnum == 2) {
				switch(seqstr[0]) {
					case '0': sasppfk(); break;
					case '1': aspfin =1; break;
					case '9': tasppfk(); break;
				}
				break;
			}
			else {
				n = (seqstr[0]-'0')*10+(seqstr[1]-'0');
				m = (seqstr[3]-'0')*10+(seqstr[4]-'0');
				vlocate(m-1, n-1);
			}
			break;
		case 'm':
		    if(seqnum == 1)  vcolor(7, 0);
		    else if(seqnum == 2) {
			switch(seqstr[0]) {
				case '0': vcolor(7,0); break;
				case '4': attr = (attr & 0xf0)+9; break;
				case '5': attr = (attr & 0xf0)+3; break;
				case '7': if(host < 3) vcolor(5, 0);
					  else attr = (attr & 0xf0)+5;
					  break;
			}
		    }
		    else if(seqnum == 3) {
			n = (seqstr[0]-'0')*10 + seqstr[1]-'0';
			switch( n ) {
				case 16 : vcolor(7, -1); break;
				case 30 : vcolor(0,  0); break;
				case 40 : vcolor(0,  2); break;
				case 41 : vcolor(2,  2); break;
				case 42 : vcolor(4,  2); break;
				case 43 : vcolor(6,  2); break;
				case 44 : vcolor(1,  2); break;
				case 45 : vcolor(3,  2); break;
				case 46 : vcolor(5,  2); break;
				case 47 : vcolor(7,  2); break;
				case 18 : case 34: vcolor(1, 0); break;
				case 17 : case 31: vcolor(2, 0); break;
				case 19 : case 35: vcolor(3, 0); break;
				case 20 : case 32: vcolor(4, 0); break;
				case 22 : case 36: vcolor(5, 0); break;
				case 21 : case 33: vcolor(6, 0); break;
				case 23 : case 37: vcolor(7, 0); break;
			}
		    }
		    break;
		case 'A': crow -= n;
			  if(crow < minrow)  crow = minrow;
			  break;
		case 'B': crow += n;
			  if(crow > maxrow)  crow = maxrow;
			  break;
		case 'C': ccol += n;
			  if(ccol > maxcol)  ccol = maxcol;
			  break;
		case 'D': ccol -= n;
			  if(ccol < mincol)  ccol = mincol;
			  break;
		case 'J':
			switch(seqstr[0]) {
			    case '0': case 'J':
				scol = ccol;  srow = crow;
				ersr();
				if(crow < maxrow) {
				    trow = minrow;  minrow = crow+1;
				    cls(aflg);	    minrow = trow;
				}
				ccol = scol;  crow = srow;
 				break;
			    case '1':
				scol = ccol;  srow = crow;
				ersl();
				if(crow > minrow) {
				    trow = maxrow;  maxrow = crow-1;
				    cls(aflg);	    maxrow = trow;
				}
				ccol = scol;  crow = srow;
 				break;
			    case '2':
				cls(aflg);  break;
			}
			break;
		case 'K':
			switch(seqstr[0]) {
			    case '0': case 'K':  ersr();  break;
			    case '1':		 ersl();  break;
			    case '2':		 ersr();  ersl();  break;
			}
			break;
		case 'M':
			if(crow < maxrow) {
				for(ccr=crow; ccr+n<=maxrow; ccr++) {
				    if(ccr+n > maxrow) break;
				    movedata(VRAM,(ccr+n)*160,VRAM,ccr*160,160);
				    movedata(ATTR,(ccr+n)*160,ATTR,ccr*160,160);
				}
			}
			trow   = minrow;	srow = crow;
			minrow = maxrow-n+1;	cls(aflg);
			minrow = trow;
			crow = srow;		ccol = mincol;
			break;
		case 'L':
			if(crow+n < maxrow) {
				for(ccr=maxrow; ccr>=crow+n; ccr--) {
				    movedata(VRAM,(ccr-n)*160,VRAM,ccr*160,160);
				    movedata(ATTR,(ccr-n)*160,ATTR,ccr*160,160);
				}
			}
			srow = minrow;  scol = maxrow;
			minrow = crow;  maxrow = crow+n-1;
			cls(aflg);
			minrow = srow;  maxrow = scol;
			ccol = mincol;
			break;
	}
}

scolor( n )
unsigned  n;
{
	switch( n ) {
		case  0: break;
		case  1: break;
		case  2: break;
		case  4: mode += 4; break;
		case  5: mode += 1; break;
		case  7: mode += 2; break;
		case  8: mode = -1; break;
		case 16: mode = -1; break;
		case 18: color = 1; break;
		case 17: color = 2; break;
		case 19: color = 3; break;
		case 20: color = 4; break;
		case 22: color = 5; break;
		case 21: color = 6; break;
		case 23: color = 7; break;
		case 30: color = 0; break;
		case 34: color = 1; break;
		case 31: color = 2; break;
		case 35: color = 3; break;
		case 32: color = 4; break;
		case 36: color = 5; break;
		case 33: color = 6; break;
		case 37: color = 7; break;
		case 40: color = 0; mode += 2; break;
		case 44: color = 1; mode += 2; break;
		case 41: color = 2; mode += 2; break;
		case 45: color = 3; mode += 2; break;
		case 42: color = 4; mode += 2; break;
		case 46: color = 5; mode += 2; break;
		case 43: color = 6; mode += 2; break;
		case 47: color = 7; mode += 2; break;
	}
}

sasppfk()
{
	aflg = 1;	aspfin = 0;
	fkey(1);
	pfdisp(3 + (kspec()&1));
	return;
}

char	sgmodes;
tasppfk()
{
	if(aflg != 2) { sgmodes = _gmodes; _gmodes = 2; }
	aflg = 2;	aspfin = 0;
	fkey(1);	pfdisp(5);
	return;
}

rasppfk()
{
	if(aflg == 2) _gmodes = sgmodes;
	aflg = 0;	moving = 0;
	fkey(1);	pfdisp(1);
	return;
}

char	_gmode  = 0;			/* graph mode  flag	*/
char	_draw   = 0;			/* specify draw or move	*/
char	_drawn  = 0;			/* specify drawn       	*/
char	_hidden	= 0;			/* graphic hidden flag	*/
char	_cleard = 0;			/* specify esc_ff input	*/

static	int	xl, xh, yl, yh;			/* received address and	*/
static	char	ci    = 0;			/* current  indicator	*/
static	int	bcnt, nxbcnt;			/* graph data counter	*/
static	int	gx   = 0, gy   = 0;	/* tektro 4010 screen addr.	*/
static	int	ginx = 0, giny = 0;	/* next gin address		*/
static	int	pcx, pcy;		/* pc-9800 screen address	*/
static	char	area[193];		/* ggetƴر			*/
#define	x0	8			/* screen original x address	*/
#define	y0	10			/* screen original y address	*/
					/* ۽ͱق̗]T邱	*/

graph( e )
unsigned char   e ;
{
	if(host<3 && code) {
		if     (e == '$' ) e = '\\';
		else if(e == '\\') e = '$' ;
	}
	switch( e & 0x60 ) {
		case 0x20:	/* x01xxxxx yh(ci=0) xh(ci=1,2,3)	*/
			switch( ci ) {
				case  4: dp();
				case  0: yh = e & 0x1f; ci = 1; return;
				case  1:
				case  2:
				case  3: xh = e & 0x1f; ci = 4; return;
			};
		case 0x60:	/* x11xxxxx yl(ci=0,1,2) or ext(ci=0,1)	*/
				/* Note: ext is not used		*/
			switch( ci ) {
				case  3:
				case  4: dp();
				case  0: ci  = 1;
				case  1:
				case  2: yl  = e & 0x1f; ci++; return;
			};
		case 0x40:	/* x10xxxxx xl(ci=0,1,2,3,4)		*/
			xl = e & 0x1f; dp(); ci = 0;
			return;
		case 0x00:	/* x00xxxxx control characters		*/
			switch( e ) {
			case cr :
			case bel: _gmode = 0; _drawn = 0; vput( e );
				  setcursor(); vcursor();
			default : return;
			}
	}
}
		
static int	x1 = 0, y1 = 0, x2 = 0, y2 = 0, patt = 0;
static char	glclr = 4, style = 0;
dp()		/* draw a line or move */
{
	gx  = xh*32 + xl; gy  = yh*32 + yl;	/* x,y address	*/
	pcx = xcnv( gx ); pcy = ycnv( gy );	/* 98ʱڽ	*/
	ginx = gx;	giny = gy;		/* set gin addr	*/
	if( _draw ) {				/*==== draw ====*/
		if( _cleard ) {
			_cleard = 0;
			gcls(); cls(1);
			if( _hidden ) chggraph();
		}
		if(! _drawn) {
			cursoroff(); _drawn = 1;/* set drawn on	*/
		}
		x1 = x2; y1 = y2; x2 = pcx; y2 = pcy;
		gline(x1, y1, x2, y2, glclr, 0, style, patt);
	}
	else {					/*==== move ====*/
		x2 = pcx; y2 = pcy;		/* to	*/
		_draw = 1;
	}
}

setstyle(c)
{
	switch( c ) {
		case 0: style = 0;			break;
		case 1: style = 1; patt = 0x9999;	break;
		case 2: style = 1; patt = 0xf99f;	break;
		case 3: style = 1; patt = 0xe7e7;	break;
		case 4: style = 1; patt = 0xfe7f;	break;
	}
}

int	xo, yo;				/* ggetڽ	*/
gin()		/* cursor input mode */
{
	int qx, qy, xs, xm, ys, ym, dd, moveon;
	unsigned char	e;

	if(_hidden) chggraph();		/* screen on */
	/* set cursor to appropriate position and init px, py */
	cursoroff();	_drawn = 0;
	if(_gmodes==1)  {
		xs = 0; xm = 1023; ys = 0; ym = 769;
	}
	else		{ 
		xs = 5; xm =  634; ys = 5; ym = 394;
	}
	qx = ginx; qy = giny;
	if(qx < xs) qx = xs;	if(qy < ys) qy = ys;
	if(qx > xm) qx = xm;	if(qy > ym) qy = ym;
	xo = -1; yo = -1;
	gcross(qx, qy);

	moveon = 1;
	while( moveon ) {
		pfscang();
		if(e = cget()) {
			if(kspec() & 0x01) dd = 7; else dd = 1;
			switch( e ) {
			case uarw: case vt: /* up arrow */
				qy += dd;
				if(qy <= ym) gcross(qx, qy);
				else	     qy -= dd;
				break;
			case darw: case lf: /* down arrow */
				qy -= dd;
				if(qy >= xs) gcross(qx, qy);
				else	     qy += dd;
			    	break;
			case larw: case bs: /* left arrow */
				qx -= dd;
				if(qx >= xs) gcross(qx, qy);
				else	     qx += dd;
				break;
			case rarw: case ff: /* right arrow */
				qx += dd;
				if(qx <= xm) gcross(qx, qy);
				else	     qx -= dd;	
				break;
			case cr: case eot:
				e = ' ';
			default:
				if(e >= 0x20) moveon = 0;
				ginx = qx;	giny = qy;
			} /*switch*/
		} /*if*/
	} /*while*/
	gput1(xcnv(xo)-5, ycnv(yo)-5, area, 193, 0); _gmode = 0;
	cursoron(); rsput( e ); sendaddr();
}

gcross(x, y)
int	x, y;
{
	int	px, py, pxo, pyo;
	px = xcnv( x );	py = ycnv( y );
	if(xo >= 0) gput1(xcnv(xo)-5, ycnv(yo)-5, area, 193, 0);
	gget(px-5, py-5, px+5, py+5, area, 193);
	gline(px-5, py, px+5, py, 5, 0, 0);
	gline(px, py-5, px, py+5, 5, 0, 0);
	xo = x;	yo = y;
}

xcnv( x )
int	x;
{	if(_gmodes==1) return(x/2 + x0); else return( x ); }

ycnv( y )
int	y;
{	if(_gmodes==1) return(399 - y/2 -y0); else return(399 - y); }
/* send cursor address */
sendaddr()
{
	rsput( (ginx >> 5  ) | 0x20 );	/* send xh		*/
	rsput( (ginx & 0x1f) | 0x20 );	/* send xl		*/
	rsput( (giny >> 5  ) | 0x20 );	/* send yh		*/
	rsput( (giny & 0x1f) | 0x20 );	/* send yl		*/
	rsput( cr ); /*rsput( eot );*/	/* send cr eot		*/
}

setcolor(c) { glclr = c; }
creset() { char e; for(e=1; e<8; e++) gcolor2(e, e); }
cblack() { char e; for(e=1; e<8; e++) gcolor2(e, 0); }
chggraph()
{
	_hidden = ! _hidden;
	if( _hidden )	cblack();
	else		creset();
}

cursoron()
{
	inregs.h.ah = 0x11;
	int86(0x18, &inregs, &outregs);
}

cursoroff()
{
	inregs.h.ah = 0x12;
	int86(0x18, &inregs, &outregs);
}

setcursor() { vlocate(pcx/8, pcy/16); }

hicursor()	/* high cursor */
{
	outp(0x62, 0x4b);
	outp(0x60, 0x8f);	/*cs=1, 00, L/R=01111(high resolution)	*/
	outp(0x60, 0x20);	/*BLl=00, BD=1(stop), CST=00000		*/
	outp(0x60, 0x3b);	/*CFI=00111, BLh=011			*/
}

locursor()	/* low cursor */
{
	outp(0x62, 0x4b);
	outp(0x60, 0x8f);	/*cs=1, 00, L/R=01111(high resolution)	*/
	outp(0x60, 0x28);	/*BLl=00, BD=1(stop), CST=01000		*/
	outp(0x60, 0x7b);	/*CFI=01111, BLh=011			*/
}

udcursor()	/* underline cursor */
{
	outp(0x62, 0x4b);
	outp(0x60, 0x8f);	/*cs=1, 00, L/R=01111(high resolution)	*/
	outp(0x60, 0x0e);	/*BLl=00, BD=0(blink), CST=01110	*/
	outp(0x60, 0x7b);	/*CFI=01111, BLh=011			*/
}

rcursor()	/* reset cursor */
{
	outp(0x62, 0x4b);
	outp(0x60, 0x8f);	/*cs=1, 00, L/R=01111(high resolution)	*/
	outp(0x60, 0x00);	/*BLl=00, BD=0(blink), CST=00000	*/
	outp(0x60, 0x7b);	/*CFI=01111, BLh=011			*/
}
